/**
* Title:        ChatPanel<p>
* Description:  <p>
* @author Paulo Henrique Fisch de Brito
* @version 1.0
*/
package colab.client.gui;

import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;

public class FocusPanel extends JPanel {

    private static final int outSize = 2;
    private static final int inSize = 4;

    private static final Color focusColor = Color.blue;
    private static final Color notFocusColor = Color.black;

    private static final Border outBorder = BorderFactory.createEmptyBorder (outSize, outSize, outSize, outSize);
    private static final Border inBorder = BorderFactory.createEmptyBorder (inSize, inSize, inSize, inSize);

    private static final Border focusBorder = BorderFactory.createCompoundBorder (outBorder, BorderFactory.createCompoundBorder(BorderFactory.createLineBorder(focusColor), inBorder));
    private static final Border notFocusBorder = BorderFactory.createCompoundBorder (outBorder, BorderFactory.createCompoundBorder(BorderFactory.createLineBorder(notFocusColor), inBorder));

    private boolean focus = true;

    public FocusPanel () {
	setFocus(focus);
    }

    public void setFocus (boolean _focus) {
	focus = _focus;
	if (focus)
	    this.setBorder (focusBorder);
	else
	    this.setBorder (notFocusBorder);
    }

}
