package colab.client.gui;

import java.io.*;
import colab.client.tool.*;
import colab.util.tool.iToolModel;
import ice.iblite.Browser;
import javax.swing.*;
import java.awt.*;
import java.io.*;

public class ModulesOwner {

    static ToolFactory toolFactory;
    static ToolPanel   toolPanel;
    static ToolPanel   colToolPanel;
    static ChatPanel   chatPanel;
    static ForumPanel  forumPanel;
    static MailPanel   mailPanel;
    static GroupPanel  groupPanel;
    static Browser     browserPanel;
    static Browser     mainBrowserPanel;
    static JFrame      browserFrame;
    static Notepad     notepad;
    static JFrame      notepadFrame;

    public ModulesOwner () {
    }

    public static ToolFactory getToolFactory() {

	if (toolFactory == null)
	    toolFactory = ToolFactoryOwner.getFactory();

	return toolFactory;
    }

    public static ToolPanel getToolPanel (iToolModel _toolModel) {

	toolPanel = ToolFactoryOwner.getFactory().createToolPanel (_toolModel);

	return toolPanel;
    }

    public static ToolPanel getCollaborativeToolPanel (iToolModel _toolModel) {

	toolPanel = ToolFactoryOwner.getFactory().createCollaborativeToolPanel (_toolModel);

	return toolPanel;
    }

    public static ChatPanel getChatPanel() throws IOException {

	if (chatPanel == null)
	    chatPanel = new ChatPanel();

	return chatPanel;
    }

    public static boolean isThereChatPanel() {

	return !( null == chatPanel);

    }

    public static MailPanel getMailPanel () {

	if (mailPanel == null)
	    mailPanel = new MailPanel();

	return mailPanel;
    }

    public static boolean isThereMailPanel() {

	return !( null == mailPanel);

    }

    public static GroupPanel getGroupPanel () {

	if (groupPanel == null)
	    groupPanel = new GroupPanel();

	return groupPanel;
    }

    public static boolean isThereGroupPanel() {

	return !( null == groupPanel);

    }

    public static ForumPanel getForumPanel () {

	if (forumPanel == null)
	    forumPanel = new ForumPanel();

	return forumPanel;
    }

    public static boolean isThereForumPanel() {

	return !( null == forumPanel);

    }

    public static Notepad getNotepad () {

	if (notepad == null)
	    notepad = new Notepad();

	return notepad;
    }

    public static JFrame getNotepadFrame() {

	if (null == notepadFrame) {
	    notepadFrame = new JFrame ("Editor de Relatorios");
	    notepadFrame.setSize(600,480);
	    Container notepadContainer = notepadFrame.getContentPane();
	    notepadContainer.setLayout(new BorderLayout());
	    notepadContainer.add (getNotepad(), BorderLayout.CENTER);

	}

	return notepadFrame;
    }

    public static boolean isThereNotepad() {

	return !( null == notepad);

    }

    public static Browser getMainBrowserPanel () {

	if (mainBrowserPanel == null)
	    mainBrowserPanel = new Browser();

	return mainBrowserPanel;
    }

    public static Browser getBrowserPanel () {

	if (browserPanel == null)
	    browserPanel = new Browser();

	return browserPanel;
    }

    public static JFrame getBrowserFrame() {

	if (browserFrame == null) {

	    browserFrame = new JFrame("Browser");
	    browserFrame.setSize (480, 640);
	    Container container = browserFrame.getContentPane();
	    container.setLayout(new BorderLayout());
	    container.add (getBrowserPanel(), BorderLayout.CENTER);

	}

	return browserFrame;
    }

}
