package colab.client.tool.ploter;

/* JJT: 0.2.2 */




public class ASTCotgh extends SimpleNode {
  ASTCotgh(String id) {
    super(id);
  }

  public static Node jjtCreate(String id) {
    return new ASTCotgh(id);
  }
  
  // added
  
  public void Eval(State s) throws ArithmeticException {
    jjtGetChild(0).Eval(s);
    double e=Math.exp(2*s.pop());
    s.push((e+1)/(e-1));
  }

  public String Expression(int l) {
    return "cotgh("+jjtGetChild(0).Expression(0)+")";
  }
  
  public Node Derivative() {
    ASTSqr nodeSqr=new ASTSqr("Sqr");
    ASTDiv nodeDiv=new ASTDiv("Div");
    ASTSub nodeSub=new ASTSub("Sub");
    ASTNeg nodeNeg1=new ASTNeg("Neg");
    ASTNeg nodeNeg2=new ASTNeg("Neg");
    ASTExp nodeExp1=new ASTExp("Exp");
    ASTExp nodeExp2=new ASTExp("Exp");
    
    nodeExp1.jjtAddChild(jjtGetChild(0));
    nodeNeg1.jjtAddChild(jjtGetChild(0));
    nodeExp2.jjtAddChild(nodeNeg1);    
    nodeSub.jjtAddChild(nodeExp1);    
    nodeSub.jjtAddChild(nodeExp2);    
    nodeDiv.jjtAddChild(ASTRealValue.TWO);    
    nodeDiv.jjtAddChild(nodeSub);    
    nodeSqr.jjtAddChild(nodeDiv);
    nodeNeg2.jjtAddChild(nodeSqr);
    
    return nodeNeg2;
  }
  
}
