package colab.client.tool.ploter;

/* JJT: 0.2.2 */




public class ASTExponent extends SimpleNode {
  ASTExponent(String id) {
    super(id);
  }

  public static Node jjtCreate(String id) {
    return new ASTExponent(id);
  }

  // added

  public void Eval(State s) throws ArithmeticException {
    jjtGetChild(1).Eval(s);
    jjtGetChild(0).Eval(s);
    s.push(Math.pow(s.pop(),s.pop()));
  }

  public String Expression(int l) {
    if (l>6) 
      return "("+jjtGetChild(0).Expression(6)+"^"+jjtGetChild(1).Expression(6)+")";
    else
      return jjtGetChild(0).Expression(6)+"^"+jjtGetChild(1).Expression(6);
  }
  
  public Node Derivative() {
    ASTAdd nodeAdd=new ASTAdd("Add");
    ASTMult nodeMult1=new ASTMult("Mult");
    ASTMult nodeMult2=new ASTMult("Mult");
    ASTMult nodeMult3=new ASTMult("Mult");
    ASTDiv nodeDiv=new ASTDiv("Div");
    ASTLn nodeLn=new ASTLn("Ln");
    
    nodeLn.jjtAddChild(jjtGetChild(0));
    nodeMult1.jjtAddChild(jjtGetChild(1).Derivative());
    nodeMult1.jjtAddChild(nodeLn);    
    nodeMult2.jjtAddChild(jjtGetChild(1));
    nodeMult2.jjtAddChild(jjtGetChild(0).Derivative());    
    nodeDiv.jjtAddChild(nodeMult2);
    nodeDiv.jjtAddChild(jjtGetChild(0));
    nodeAdd.jjtAddChild(nodeMult1);
    nodeAdd.jjtAddChild(nodeDiv);
    nodeMult3.jjtAddChild(this);
    nodeMult3.jjtAddChild(nodeAdd);
    
    return nodeMult3;
  }

}
