package colab.client.tool.ploter;

/* JJT: 0.2.2 */




public class ASTLog10 extends SimpleNode {
  ASTLog10(String id) {
    super(id);
  }

  public static Node jjtCreate(String id) {
    return new ASTLog10(id);
  }
  
  // added
  
  private static double CTE=1.0/Math.log(10);
  
  public void Eval(State s) throws ArithmeticException {
    jjtGetChild(0).Eval(s);
    s.push(Math.log(s.pop())*CTE);
  }

  public String Expression(int l) {
    return "log10("+jjtGetChild(0).Expression(0)+")";
  }
  
  public Node Derivative() {
    ASTDiv nodeDiv=new ASTDiv("Div");
    ASTMult nodeMult=new ASTMult("Mult");
        
    nodeMult.jjtAddChild(ASTRealValue.LOG10);
    nodeMult.jjtAddChild(jjtGetChild(0));
    nodeDiv.jjtAddChild(jjtGetChild(0).Derivative());
    nodeDiv.jjtAddChild(nodeMult);
    
    return nodeDiv;
  }
  
}
