package colab.client.tool.ploter;

/* JJT: 0.2.2 */




public class ASTMult extends SimpleNode {
  ASTMult(String id) {
    super(id);
  }

  public static Node jjtCreate(String id) {
    return new ASTMult(id);
  }

  // added

  public void Eval(State s) throws ArithmeticException {
    jjtGetChild(1).Eval(s);
    jjtGetChild(0).Eval(s);
    s.push(s.pop()*s.pop());
  }

  public String Expression(int l) {
    if (l>2) 
      return "("+jjtGetChild(0).Expression(3)+"*"+jjtGetChild(1).Expression(3)+")";
    else
      return jjtGetChild(0).Expression(3)+"*"+jjtGetChild(1).Expression(3);
  }

  public Node Derivative() {
    ASTAdd nodeAdd=new ASTAdd("Add");
    ASTMult nodeMult1=new ASTMult("Mult");
    ASTMult nodeMult2=new ASTMult("Mult");    
    nodeMult1.jjtAddChild(jjtGetChild(1));
    nodeMult1.jjtAddChild(jjtGetChild(0).Derivative());
    nodeMult2.jjtAddChild(jjtGetChild(0));
    nodeMult2.jjtAddChild(jjtGetChild(1).Derivative());
    nodeAdd.jjtAddChild(nodeMult1);
    nodeAdd.jjtAddChild(nodeMult2);
    
    return nodeAdd;
  }

}
