package colab.client.tool.ploter;

/* JJT: 0.2.2 */




public class ASTSqrt extends SimpleNode {
  ASTSqrt(String id) {
    super(id);
  }

  public static Node jjtCreate(String id) {
    return new ASTSqrt(id);
  }

  // added

  public void Eval(State s) throws ArithmeticException {
    jjtGetChild(0).Eval(s);
    s.push(Math.sqrt(s.pop()));
  }

  public String Expression(int l) {
    return "sqrt("+jjtGetChild(0).Expression(0)+")";
  }

  public Node Derivative() {
    ASTMult nodeMult=new ASTMult("Mult");
    ASTDiv nodeDiv=new ASTDiv("Div");

    nodeMult.jjtAddChild(ASTRealValue.TWO);
    nodeMult.jjtAddChild(this);
    nodeDiv.jjtAddChild(jjtGetChild(0).Derivative());
    nodeDiv.jjtAddChild(nodeMult);

    return nodeDiv;
  }

}
