package colab.client.tool.ploter;

/* JJT: 0.2.2 */




public class ASTTanh extends SimpleNode {
  ASTTanh(String id) {
    super(id);
  }

  public static Node jjtCreate(String id) {
    return new ASTTanh(id);
  }
  
  // added
  
  public void Eval(State s) throws ArithmeticException {
    jjtGetChild(0).Eval(s);
    double e=Math.exp(2*s.pop());
    s.push((e-1)/(e+1));
  }

  public String Expression(int l) {
    return "tanh("+jjtGetChild(0).Expression(0)+")";
  }
  
public Node Derivative() {
    ASTSqr nodeSqr=new ASTSqr("Sqr");
    ASTDiv nodeDiv=new ASTDiv("Div");
    ASTAdd nodeAdd=new ASTAdd("Add");
    ASTNeg nodeNeg1=new ASTNeg("Neg");
    ASTExp nodeExp1=new ASTExp("Exp");
    ASTExp nodeExp2=new ASTExp("Exp");
    
    nodeExp1.jjtAddChild(jjtGetChild(0));
    nodeNeg1.jjtAddChild(jjtGetChild(0));
    nodeExp2.jjtAddChild(nodeNeg1);    
    nodeAdd.jjtAddChild(nodeExp1);    
    nodeAdd.jjtAddChild(nodeExp2);    
    nodeDiv.jjtAddChild(ASTRealValue.TWO);    
    nodeDiv.jjtAddChild(nodeAdd);    
    nodeSqr.jjtAddChild(nodeDiv);
    
    return nodeSqr;
  }
  
}
