package colab.client.tool.ploter;

/* JJT: 0.2.2 */




public class ASTAcosh extends SimpleNode {
  ASTAcosh(String id) {
    super(id);
  }

  public static Node jjtCreate(String id) {
    return new ASTAcosh(id);
  }
  
  // added
  
  public void Eval(State s) throws ArithmeticException {
    jjtGetChild(0).Eval(s);
    double x=s.pop();
    s.push(Math.log(x+Math.sqrt(x*x-1)));
  }

  public String Expression(int l) {
    return "acosh("+jjtGetChild(0).Expression(0)+")";
  }
  
  public Node Derivative() {
    ASTSub nodeSub=new ASTSub("Sub");
    ASTSqr nodeSqr=new ASTSqr("Sqr");
    ASTSqrt nodeSqrt=new ASTSqrt("Sqrt");
    ASTDiv nodeDiv=new ASTDiv("Div");
    
    nodeSqr.jjtAddChild(jjtGetChild(0));
    nodeSub.jjtAddChild(nodeSqr);
    nodeSub.jjtAddChild(ASTRealValue.ONE);
    nodeSqrt.jjtAddChild(nodeSub);
    nodeDiv.jjtAddChild(jjtGetChild(0).Derivative());
    nodeDiv.jjtAddChild(nodeSqrt);
    
    return nodeDiv;
  }
  
}
