package colab.client.tool.ploter;

/* JJT: 0.2.2 */




public class ASTAtan extends SimpleNode {
  ASTAtan(String id) {
    super(id);
  }

  public static Node jjtCreate(String id) {
    return new ASTAtan(id);
  }
  
  // added
  
  public void Eval(State s) throws ArithmeticException {
    jjtGetChild(0).Eval(s);
    s.push(Math.atan(s.pop()));
  }
  
  public String Expression(int l) {
    return "atan("+jjtGetChild(0).Expression(0)+")";
  }

  public Node Derivative() {
    ASTAdd nodeAdd=new ASTAdd("Add");
    ASTSqr nodeSqr=new ASTSqr("Sqr");
    ASTDiv nodeDiv=new ASTDiv("Div");
    
    nodeSqr.jjtAddChild(jjtGetChild(0));
    nodeAdd.jjtAddChild(ASTRealValue.ONE);
    nodeAdd.jjtAddChild(nodeSqr);
    nodeDiv.jjtAddChild(jjtGetChild(0).Derivative());
    nodeDiv.jjtAddChild(nodeAdd);
    
    return nodeDiv;
  }

}
