package colab.client.tool.ploter;

/* JJT: 0.2.2 */




public class ASTAtanh extends SimpleNode {
  ASTAtanh(String id) {
    super(id);
  }

  public static Node jjtCreate(String id) {
    return new ASTAtanh(id);
  }
  
  // added
  
  public void Eval(State s) throws ArithmeticException {
    jjtGetChild(0).Eval(s);
    double x=s.pop();
    s.push(Math.log((1+x)/(1-x))/2.0);
  }
  
  public String Expression(int l) {
    return "atanh("+jjtGetChild(0).Expression(0)+")";
  }

  public Node Derivative() {
    ASTSub nodeSub=new ASTSub("Sub");
    ASTSqr nodeSqr=new ASTSqr("Sqr");
    ASTDiv nodeDiv=new ASTDiv("Div");
    
    nodeSqr.jjtAddChild(jjtGetChild(0));
    nodeSub.jjtAddChild(ASTRealValue.ONE);
    nodeSub.jjtAddChild(nodeSqr);
    nodeDiv.jjtAddChild(jjtGetChild(0).Derivative());
    nodeDiv.jjtAddChild(nodeSub);
    
    return nodeDiv;
  }

  
}
