package colab.client.tool.ploter;

/* JJT: 0.2.2 */




public class ASTCotg extends SimpleNode {
  ASTCotg(String id) {
    super(id);
  }

  public static Node jjtCreate(String id) {
    return new ASTCotg(id);
  }
  
  // added
  
  public void Eval(State s) throws ArithmeticException {
    jjtGetChild(0).Eval(s);
    s.push(1.0/Math.tan(s.pop()));
  }

  public String Expression(int l) {
    return "cotg("+jjtGetChild(0).Expression(0)+")";
  }
  
  public Node Derivative() {
    ASTSqr nodeSqr=new ASTSqr("Sqr");
    ASTSin nodeSin=new ASTSin("Sin");
    ASTDiv nodeDiv=new ASTDiv("Div");
    ASTNeg nodeNeg=new ASTNeg("Neg");
    
    nodeSin.jjtAddChild(jjtGetChild(0));
    nodeSqr.jjtAddChild(nodeSin);
    nodeDiv.jjtAddChild(jjtGetChild(0).Derivative());
    nodeDiv.jjtAddChild(nodeSqr);
    nodeNeg.jjtAddChild(nodeDiv);
    
    return nodeNeg;
  }
  
}
