package colab.client.tool.ploter;

/* JJT: 0.2.2 */




public class ASTRealValue extends SimpleNode {
  ASTRealValue(String id) {
    super(id);
  }

  public static Node jjtCreate(String id) {
    return new ASTRealValue(id);
  }
  
  // added
  
  public static ASTRealValue ZERO=constant(0.0);
  public static ASTRealValue ONE=constant(1.0);
  public static ASTRealValue TWO=constant(2.0);
  public static ASTRealValue LOG10=constant(Math.log(10.0));
  public static ASTRealValue PI=constant(Math.PI);
  public static ASTRealValue E=constant(Math.E);
  
  private double v;
  
  public static ASTRealValue constant(double v) {
    ASTRealValue k=new ASTRealValue("Realvalue");
    k.v=v;
    return k;
  }
  
  public void setValue(String s) {
    v=(new Double(s)).doubleValue();
  }

  public void setValue(double v) {
    this.v=v;
  }

  public double getValue() {
    return v;
  }
  
  public void Eval(State s) throws ArithmeticException {
    s.push(v);
  }  
  
  public String toString() {
    return "RealValue: "+v;
  }
  
  public String Expression(int l) {
    return ""+v;
  }
  
  public Node Derivative() {  
    return ZERO;
  }
  
}
