package colab.server;

import java.rmi.*;
//import java.rmi.server.*;
//import java.util.*;
//import colab.util.*;
import java.rmi.registry.LocateRegistry;
import colab.server.chat.*;
import colab.util.*;
import colab.util.chat.*;
import colab.server.group.*;
import colab.util.group.*;
import colab.server.mail.*;
import colab.util.mail.*;
import colab.server.forum.*;
import colab.util.forum.*;
import colab.server.file.*;
import colab.server.*;
import colab.util.file.*;

public class ColabServer {

    public ColabServer() {
    }

    public static void main(String[] args) {

      String host;
      if (args.length == 0) {
        System.out.println ("Rodando local");
        host = "";
      } else
        host = args[0];

	try {
	    LocateRegistry.createRegistry ( RegistryPort.getPortInt() );
	} catch (RemoteException e) {
	    System.out.println ("Nao foi possivel levantar o servico de Registry.\n");
	    e.printStackTrace();
	}

	String erro = "";

	//Instalando o securityManager
	if (System.getSecurityManager() == null) {
            System.setSecurityManager(new RMISecurityManager());
        }

        try {

	    //Verifying persistence directory
	    Persistence.verifyingPersistence();

	    // Criando Group Server
	    erro = "GroupServer exception: ";
            iGroupServer group = new GroupServer(host);
            System.out.println("GroupServer bound");

	    // Criando FileServer
	    erro = "FileServer exception: ";
            iFileServer file = new FileServer(host, group);
            System.out.println("FileServer bound");

	    // Criando Mail Server
	    erro = "MailServer exception: ";
            iMailServer mail = new MailServer(host, group);
            System.out.println("MailServer bound");

	    // Criando Forum Server
	    erro = "ForumServer exception: ";
            iForumServer forum = new ForumServer(host, group);
            System.out.println("ForumServer bound");

	    // Criando Chat Server
	    erro = "ChatServer exception: ";
            iChatServer chat = new ChatServer(host, group);
            System.out.println("ChatServer bound");
        } catch (Exception e) {
            System.err.println(erro + e.getMessage());
            System.out.println("Pilha:");
            e.printStackTrace();
            System.exit(0);
        }

    }
}
