package colab.server;

import java.rmi.*;
//import java.rmi.server.*;
//import java.util.*;
//import colab.util.*;
import java.rmi.registry.LocateRegistry;
import colab.util.file.*;
import colab.util.chat.*;
import colab.util.chat.*;
import colab.util.group.*;
import colab.util.mail.*;
import colab.util.forum.*;
import colab.util.*;

public class ColabServerDown {

    public ColabServerDown() {
    }

    public static void main(String[] args) {

        String host;
        if (args.length == 0) {
            System.out.println ("Rodando local");
            host = "";
        } else
            host = args[0];

        // Avisando aos servidores

        // 1o: File
        try {
            iFileServer fileServer;

            String name = "//" + host + ":" + RegistryPort.getPort() + "/" + iFileServer.NAME;
            System.out.println ("Tentando: " + name);
            fileServer = (iFileServer) Naming.lookup (name);
            fileServer.exit();
        } catch (Exception e) {
            System.out.println ("Problemas para avisar FileServer." + e.getMessage());
            e.printStackTrace();
        }

        // 2o: Chat
        try {
            iChatServer chatServer;

            String name = "//" + host + ":" + RegistryPort.getPort() + "/" + iChatServer.NAME;
            System.out.println ("Tentando: " + name);
            chatServer = (iChatServer) Naming.lookup (name);
            chatServer.exit();
        } catch (Exception e) {
            System.out.println ("Problemas para avisar ChatServer." + e.getMessage());
            e.printStackTrace();
        }

        // 3o: Mail
        try {
            iMailServer mailServer;

            String name = "//" + host + ":" + RegistryPort.getPort() + "/" + iMailServer.NAME;
            System.out.println ("Tentando: " + name);
            mailServer = (iMailServer) Naming.lookup (name);
            mailServer.exit();
        } catch (Exception e) {
            System.out.println ("Problemas para avisar MailServer." + e.getMessage());
            e.printStackTrace();
        }

        // 4o: Forum
        try {
            iForumServer forumServer;

            String name = "//" + host + ":" + RegistryPort.getPort() + "/" + iForumServer.NAME;
            System.out.println ("Tentando: " + name);
            forumServer = (iForumServer) Naming.lookup (name);
            forumServer.exit();
        } catch (Exception e) {
            System.out.println ("Problemas para avisar ForumServer." + e.getMessage());
            e.printStackTrace();
        }

        // 5o: Group
        try {
            iGroupServer groupServer;

            String name = "//" + host + ":" + RegistryPort.getPort() + "/" + iGroupServer.NAME;
            System.out.println ("Tentando: " + name);
            groupServer = (iGroupServer) Naming.lookup (name);
            groupServer.exit();
        } catch (Exception e) {
            System.out.println ("Problemas para avisar GroupServer." + e.getMessage());
            e.printStackTrace();
        }
    }
}
