package colab.server;

import java.io.*;

public class Persistence {

    private static String separator = File.separator;
    private static String directory;
    
    // childs:
    public static final int BASE        =  1;
    public static final int MAIL        =  2;
    public static final int MAILBOX     =  3;
    public static final int ALLMAILS    =  4;
    public static final int USERS       =  5;
    public static final int ERROR       =  6;
    public static final int FORUM       =  7;
    public static final int FORUM_MSG   =  8;
    public static final int FORUM_USER  =  9;
    public static final int HOME_DIR    = 10;
    public static final int PUBLISH_DIR = 11;
    private static final String dirMail       = "mail" + separator;
    private static final String dirMailBox    = dirMail+"mailbox" + separator;
    private static final String dirAllMails   = dirMail+"allmails" + separator;
    private static final String dirUsers      = "users" + separator;
    private static final String dirError      = "error" + separator;
    private static final String dirForum      = "forum" + separator;
    private static final String dirForumMsg   = dirForum+"msgs" + separator;
    private static final String dirForumUser  = dirForum+"users" + separator;
    private static final String dirHome       = "home" + separator;
    private static final String dirPublish    = dirHome + "publicados" + separator;


    public Persistence() {
    }

    public static void verifyingPersistence() {

	//System.out.println ("\nVerificando qual o diretorio base de persistencia");

	String base = System.getProperty ("persistence.directory");
	if (! base.endsWith(separator))
	    base = base + separator;

	directory = base;
	
	//System.out.println ("persistence.directory="+base+"\n");
    }

    public static String getDirectory(int _dir) {

	if (null == directory)
	    verifyingPersistence();
	
        if (_dir == BASE)
            return directory;
        else if (_dir == MAIL)
            return directory+dirMail;
        else if (_dir == MAILBOX)
            return directory+dirMailBox;
        else if (_dir == ALLMAILS)
            return directory+dirAllMails;
        else if (_dir == USERS)
            return directory+dirUsers;
        else if (_dir == ERROR)
            return directory+dirError;
        else if (_dir == FORUM)
            return directory+dirForum;
        else if (_dir == FORUM_MSG)
            return directory+dirForumMsg;
        else if (_dir == FORUM_USER)
            return directory+dirForumUser;
        else if (_dir == HOME_DIR)
            return directory+dirHome;
        else if (_dir == PUBLISH_DIR)
            return directory+dirPublish;

        else return null;
    }

    public static String getDirectory() {

	if (null == directory)
	    verifyingPersistence();

        return directory;
    }

    public static void setDirectory(String _dir){
        directory = new String (_dir);
    }

    public static void write(Serializable _object, int _dir, String _name) throws FileNotFoundException, IOException {
        write (_object, getDirectory(_dir)+_name);
    }

    public static void write(Serializable _object, String _name) throws FileNotFoundException, IOException {
        FileOutputStream out = new FileOutputStream(_name);
        ObjectOutputStream s = new ObjectOutputStream(out);
        s.writeObject(_object);
        s.flush();
        out.close();
    }

    public static Object read(int _dir, String _name) throws FileNotFoundException, IOException, ClassNotFoundException {
        return read (getDirectory(_dir)+_name);
    }

    public static Object read(String _name) throws FileNotFoundException, IOException, ClassNotFoundException {
        FileInputStream in = new FileInputStream(_name);
        ObjectInputStream s = new ObjectInputStream(in);
        Object se = s.readObject();
        return se;
    }
}
