package colab.server.file;

import colab.server.*;
import java.io.*;
import colab.util.tool.*;
import javax.swing.text.StyledDocument;

public class FilePersistence {

    protected FilePersistence () {
    }

    protected static void writeModel (File _file, iToolModel _model) throws IOException {

	try {

	    FileOutputStream out = new FileOutputStream(_file);
	    ObjectOutputStream s = new ObjectOutputStream(out);
	    s.writeObject(_model);
	    s.flush();

	} catch (IOException e) {

          ErrorLog.logError ("colab.server.file.FilePersistence.writeModel()", "Problemas para gravar: " + _file.getAbsolutePath(), e);
	  throw new IOException ("Nao foi possivel salvar o arquivo.\n" + e.getMessage());

	}
    }


    protected static iToolModel readModel (File _file) throws IOException {


	try {
	    FileInputStream in = new FileInputStream(_file);
	    ObjectInputStream s = new ObjectInputStream(in);
	    iToolModel model = (iToolModel) s.readObject();

	    return model;

	} catch (Exception e) {

	    ErrorLog.logError ("colab.server.file.FilePersistence.readModel()", "Problemas para ler: " + _file.getAbsolutePath(), e);
	  throw new IOException ("Nao foi possivel abrir o arquivo.\n" + e.getMessage());

	}

    }

    protected static void writeStyledDocument (File _file, StyledDocument _document) throws IOException {

	//System.out.println ("Vou gravar StyledDocument: " + _file.getAbsolutePath());

	try {

	    FileOutputStream out = new FileOutputStream(_file);
	    ObjectOutputStream s = new ObjectOutputStream(out);
	    s.writeObject(_document);
	    s.flush();

	} catch (IOException e) {

          ErrorLog.logError ("colab.server.file.FilePersistence.writeStyledDocument()", "Problemas para gravar: " + _file.getAbsolutePath(), e);
	  throw new IOException ("Nao foi possivel salvar o arquivo.\n" + e.getMessage());

	}
    }


    protected static StyledDocument readStyledDocument (File _file) throws IOException {

	//System.out.println ("Vou ler StyledDocument: " + _file.getAbsolutePath());

	try {
	    FileInputStream in = new FileInputStream(_file);
	    ObjectInputStream s = new ObjectInputStream(in);
	    StyledDocument document = (StyledDocument) s.readObject();

	    return document;

	} catch (Exception e) {

	    ErrorLog.logError ("colab.server.file.FilePersistence.readStyledDocument()", "Problemas para ler: " + _file.getAbsolutePath(), e);
	  throw new IOException ("Nao foi possivel abrir o arquivo.\n" + e.getMessage());

	}

    }
}
