package colab.server.file;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.filechooser.*;
import java.rmi.*;
import java.rmi.server.*;
import colab.server.*;

public class RemoteFile extends File {

    String[] roots;

    public RemoteFile (File parent, String child) {
	super (parent, child);
    }

    public RemoteFile (String pathname) {
	super (pathname);
    }

    public RemoteFile (String parent, String child) {
	super (parent, child);
    }

    private void setRoots() {
	this.roots = new String[1];
	roots[0] = File.separator;
    }

    public boolean createNewFile() throws IOException {
	this.destaque("createNewFile");

	return super.createNewFile();
    }

    private void destaque (String _str) {

	//System.out.println (_str);

    }

    public File getAbsoluteFile() {
	this.destaque("getAbsoluteFile");

	return super.getAbsoluteFile();
    }


    public String getAbsolutePath() {
	this.destaque("getAbsolutePath: " + super.getAbsolutePath());

	return this.removeDriveLetter(super.getAbsolutePath());
    }

    public File getCanonicalFile() throws IOException {
	this.destaque("getCanonicalFile");

	return super.getCanonicalFile();
    }

    public String getCanonicalPath() throws IOException {
	this.destaque("getCanonicalPath: " + super.getCanonicalPath());

	return this.removeDriveLetter(super.getCanonicalPath());
    }

    public File getParentFile() {
	this.destaque("getParentFile");

	return super.getParentFile();
    }

    public String getParent() {
	String parent = super.getParent();
	this.destaque ("getParent(): " + parent);

	if (null == parent)
	    return null;

        return this.removeDriveLetter (parent);
    }

    public String getPath() {
	this.destaque ("getPath: " + super.getPath());

	return super.getPath();
    }

    private String removeDriveLetter (String _path) {

	this.destaque ("removeDriveLetter: " + _path + " -> ");

	if (_path.indexOf(":") == -1) {
	    this.destaque ("");
	    return _path;
	}

	String path = _path.substring (_path.indexOf(":")+1);
	this.destaque (path);

	return path;
    }
}
