package colab.server.forum;

import colab.server.*;
import colab.util.group.User;
import colab.util.forum.*;
import java.io.*;
import java.util.*;

public class ForumModel implements Serializable, iPersistent {

    private String room;
    private long   uniqueID;
    private Vector forumMsgs;
    private Date   last;

    private transient boolean ServerGoingDown = false;

    public ForumModel(String _room) {
        room = _room;
        uniqueID = 0;
        forumMsgs = new Vector();
	last = new Date();
    }

    public void exit() {
        ServerGoingDown = true;
    }

    public int getSize() {
	return forumMsgs.size();
    }

    public void beforeSave() {
        //
    }

    public void afterSave(){
        //
        ServerGoingDown = false;
    }

    protected String getRoom() {
        return room;
    }

    protected String getNextId () {
        uniqueID++;
        return String.valueOf(uniqueID);
    }

    protected void receive (ForumMsg _msg) {

	_msg.setId (this.getNextId());
	System.out.println ("salvar ForumMsg");
	//ForumPersistence.writeForumMsg (_msg);
        forumMsgs.add (_msg);
        System.out.println ("Recebi forumMsg, agora sao "+forumMsgs.size());
    }


    public ForumMsg[] getMsgs() {

        ForumMsg[] arrayForum = null;

        try {
	    arrayForum = new ForumMsg[forumMsgs.size()];
	    arrayForum = (ForumMsg[]) forumMsgs.toArray(arrayForum);
        } catch (Exception e) {
            ErrorLog.logError ("colab.server.forum.ForumModel.getList()", "", e);
            System.out.println ("Need to make error log. ForumModel.getList():" + e.getMessage());
        }

        return arrayForum;
    }

    public ForumMsg[] getMsgs(Date _date) {

	int i = forumMsgs.size();

	if (0 == i)
	    return null;

	boolean before = true;
	int count = 0;
	while ( before && i > 0){

	    i--;
	    before = _date.before ( ((ForumMsg) forumMsgs.elementAt(i)).getDate());

	    if (before)
		count++;

	}

	if (count > 0 ) {
	    ForumMsg[] newMsgs = new ForumMsg[count];

	    for (int j=forumMsgs.size()-count, k=0; j < forumMsgs.size(); j++, k++)
		newMsgs[k] = (ForumMsg) forumMsgs.elementAt(j);

	    return newMsgs;
	}

	return null;
    }

}
