package colab.server.forum;

import colab.server.*;
import colab.util.forum.*;
import java.io.*;

public class ForumPersistence {

    // TYPES OF USER
    protected ForumPersistence () {
    }

    protected static void writeForumMsg (ForumMsg _forumMsg) {
	String dir = Persistence.getDirectory (Persistence.FORUM_MSG);

	try {
	    FileOutputStream out = new FileOutputStream(dir+_forumMsg.getId());
	    ObjectOutputStream s = new ObjectOutputStream(out);
	    s.writeObject(_forumMsg);
	    s.flush();
	} catch (Exception e) {
          ErrorLog.logError ("colab.server.forum.ForumPersistence.writeForumMsg()", "Problemas para gravar ForumMsg " + _forumMsg.getId(), e);
	}
    }

    protected static ForumMsg readForumMsg (String _id) {
	String dir = Persistence.getDirectory (Persistence.FORUM_MSG);

	try {
	    FileInputStream in = new FileInputStream(dir+_id);
	    ObjectInputStream s = new ObjectInputStream(in);
	    ForumMsg forumMsg = (ForumMsg) s.readObject();

	    return forumMsg;
	} catch (Exception e) {
          ErrorLog.logError ("colab.server.forum.ForumPersistence.readForumMsg()", "Problemas para ler ForumMsg " + _id, e);}
	return null;
    }

    protected static void writeForumModel (ForumModel _forumModel) {
	String dir = Persistence.getDirectory (Persistence.FORUM);
	String file = dir + _forumModel.getRoom();

	try {
	    FileOutputStream out = new FileOutputStream(file);
	    ObjectOutputStream s = new ObjectOutputStream(out);
	    s.writeObject(_forumModel);
	    s.flush();
	} catch (IOException e) {
	    ErrorLog.logError ("colab.server.forum.ForumPersistence.writeForumModel()", "Problemas para gravar o ForumModel de " + file, e);
	}
    }

    protected static ForumModel readForumModel (String _room) {
	String dir = Persistence.getDirectory (Persistence.FORUM);
	String file = dir + _room;

	try {
	    FileInputStream in = new FileInputStream(file);
	    ObjectInputStream s = new ObjectInputStream(in);
	    ForumModel forumModel = (ForumModel) s.readObject();

	    return forumModel;
	} catch (FileNotFoundException e) {
	    // ok
	    return null;
	} catch (Exception e) {
	    System.out.println ("colab.server.forum.ForumPersistence.readForumModel(): Problemas para ler o ForumModel de " + file);
	    ErrorLog.logError ("colab.server.forum.ForumPersistence.readForumModel()", "Problemas para ler o ForumModel de " + file, e);
	    e.printStackTrace();
	}
	return null;
    }

    protected static void writeForumTopics (ForumTopics _forumTopics) {
	String dir = Persistence.getDirectory (Persistence.FORUM);
	String file = dir + ForumTopics.NAME;

	try {
	    FileOutputStream out = new FileOutputStream(file);
	    ObjectOutputStream s = new ObjectOutputStream(out);
	    s.writeObject(_forumTopics);
	    s.flush();
	} catch (IOException e) {
	    ErrorLog.logError ("colab.server.forum.ForumPersistence.writeForumTopics()", "Problemas para gravar o ForumTopics de " + file, e);
	}
    }

    protected static ForumTopics readForumTopics () {
	String dir = Persistence.getDirectory (Persistence.FORUM);
	String file = dir + ForumTopics.NAME;

	try {
	    FileInputStream in = new FileInputStream(file);
	    ObjectInputStream s = new ObjectInputStream(in);
	    ForumTopics forumTopics = (ForumTopics) s.readObject();

	    return forumTopics;
	} catch (Exception e) {
	    ErrorLog.logError ("colab.server.forum.ForumPersistence.readForumTopics()", "Problemas para ler o ForumTopics de " + file, e);
	}
	return null;
    }

    protected static void writeUserModel (ForumUserModel _userModel) {
	String dir = Persistence.getDirectory (Persistence.FORUM_USER);
	String file = dir + _userModel.getLoginName();

	try {
	    FileOutputStream out = new FileOutputStream(file);
	    ObjectOutputStream s = new ObjectOutputStream(out);
	    s.writeObject(_userModel);
	    s.flush();
	} catch (IOException e) {
	    ErrorLog.logError ("colab.server.forum.ForumPersistence.writeUserModel()", "Problemas para gravar o UserModel de " + file, e);
	}
    }

    protected static ForumUserModel readUserModel (String _loginName) {
	String dir = Persistence.getDirectory (Persistence.FORUM_USER);
	String file = dir + _loginName;

	try {
	    FileInputStream in = new FileInputStream(file);
	    ObjectInputStream s = new ObjectInputStream(in);
	    ForumUserModel userModel = (ForumUserModel) s.readObject();

	    return userModel;
	} catch (Exception e) {
	    ErrorLog.logError ("colab.server.forum.ForumPersistence.readForumModel()", "Problemas para ler o UserModel de " + file, e);
	}
	return null;
    }

}
