package colab.server.mail;

import colab.server.*;
import colab.util.mail.*;
import java.io.*;

public class MailPersistence {

    // TYPES OF USER
    protected MailPersistence () {
    }

    protected static void writeMailBox (MailBox _mailBox, String _loginName) {
	String dir = Persistence.getDirectory (Persistence.MAILBOX);
	System.out.println ("Vou salvar mail box: " + dir+_loginName);
	try {
	    FileOutputStream out = new FileOutputStream(dir+_loginName);
	    ObjectOutputStream s = new ObjectOutputStream(out);
	    s.writeObject(_mailBox);
	    s.flush();
	} catch (IOException e) {
          ErrorLog.logError ("colab.server.mail.MailPersistence.writeMailBox()", "Problemas para gravar o MailBox de " + _loginName, e);
	}
    }

    protected static MailBox readMailBox (String _loginName) {
	String dir = Persistence.getDirectory (Persistence.MAILBOX);
	System.out.println ("Vou ler mail box: " + dir+_loginName);

	try {
	    FileInputStream in = new FileInputStream(dir+_loginName);
	    ObjectInputStream s = new ObjectInputStream(in);
	    MailBox mailBox = (MailBox) s.readObject();

	    return mailBox;
	} catch (Exception e) {
          ErrorLog.logError ("colab.server.mail.MailPersistence.readMailBox()", "Problemas para ler o MailBox de " + _loginName, e);
	}
	return null;
    }

    protected static void writeMailMsg (MailMsg _mailMsg) {
	String dir = Persistence.getDirectory (Persistence.ALLMAILS);
	System.out.println ("Vou salvar mail msg: " + dir+_mailMsg.getId());

	try {
	    FileOutputStream out = new FileOutputStream(dir+_mailMsg.getId());
	    ObjectOutputStream s = new ObjectOutputStream(out);
	    s.writeObject(_mailMsg);
	    s.flush();
	} catch (Exception e) {
          ErrorLog.logError ("colab.server.mail.MailPersistence.writeMailMsg()", "Problemas para ler MailMsg " + _mailMsg.getId(), e);
	}
    }

    protected static MailMsg readMailMsg (String _id) {
	String dir = Persistence.getDirectory (Persistence.ALLMAILS);
	System.out.println ("Vou ler mail msg: " + dir+_id);

	try {
	    FileInputStream in = new FileInputStream(dir+_id);
	    ObjectInputStream s = new ObjectInputStream(in);
	    MailMsg mailMsg = (MailMsg) s.readObject();

	    return mailMsg;
	} catch (Exception e) {
          ErrorLog.logError ("colab.server.mail.MailPersistence.readMailMsg()", "Problemas para ler MailMsg " + _id, e);}
	return null;
    }
}
