package colab.util.file;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.io.*;
import javax.swing.text.StyledDocument;
import colab.util.*;
import colab.util.tool.*;

public interface iRemoteFileSystem extends Remote {

    File createFileObject(File dir, String filename) throws RemoteException, ServerIsGoingDownException;

    File createFileObject(String path) throws RemoteException, ServerIsGoingDownException;

    File createNewFolder(File containingDir) throws RemoteException, ServerIsGoingDownException;

    File[] getFiles(File dir, boolean useFileHiding) throws RemoteException, ServerIsGoingDownException;

    File getHomeDirectory() throws RemoteException, ServerIsGoingDownException;

    File getParentDirectory(File dir) throws RemoteException, ServerIsGoingDownException;

    File[] getRoots() throws RemoteException, ServerIsGoingDownException;

    boolean isHiddenFile(File f) throws RemoteException, ServerIsGoingDownException;

    boolean isRoot(File f) throws RemoteException, ServerIsGoingDownException;

    iToolModel openModel (File _file) throws RemoteException, ServerIsGoingDownException, IOException;

    void saveModel (File _file, iToolModel _model) throws RemoteException, ServerIsGoingDownException, IOException;

    StyledDocument openStyledDocument (File _file) throws RemoteException, ServerIsGoingDownException, IOException;

    void saveStyledDocument (File _file, StyledDocument _document) throws RemoteException, ServerIsGoingDownException, IOException;

    void publishModel (iToolModel _model) throws RemoteException, ServerIsGoingDownException, IOException;
}
