package colab.util.forum;

import colab.util.*;
import java.util.*;
import java.io.*;

public class ForumMsg implements Serializable {

    private String   sender;
    private String   room;
    private String   topic;
    private String   subject;
    private String   id;
    private Date     date;
    private String   replyToId;
    private String   body;
    private boolean  anonymity;

    public ForumMsg (String _sender, String _topic, String _subject, String _body) {
	sender    =  _sender;
	topic     = _topic;
	subject   = _subject;
	body      = _body;
	id        = null;
	date      = new Date();
	replyToId = null;
    }

    public ForumMsg (String _sender, String _topic, String _subject, String _body, String _replyToId) {
	sender    =  _sender;
	topic     = _topic;
	subject   = _subject;
	body      = _body;
	id        = null;
	date      = new Date();
	replyToId = _replyToId;
    }

    public String getRoom() {
	return room;
    }

    public void setRoom (String _room) {
	room = _room;
    }

    public String getTopic() {
	return topic;
    }

    public void setTopic(String _topic) {
	topic = _topic;
    }

    public String getSubject() {
	return subject;
    }

    public void setSubject(String _subject) {
	subject = _subject;
    }

    public boolean getReaded () {
	// only avaiable with PersonalizedForumMsg
	return false;
    }

    public void setReaded (boolean _readed) {
	// only avaiable with PersonalizedForumMsg
    }

    public String getSender() {
	return sender;
    }

    public void setSender(String _sender) {
	sender = _sender;
    }

    public String getBody() {
	return body;
    }

    public void setBody(String _body) {
	body = _body;
    }

    public String getId() {
	return id;
    }

    public void setId (String _id) {
	id = _id;
    }

    public Date getDate() {
	return date;
    }

    public void setDate(Date _date) {
	date = _date;
    }

    public boolean getAnonymity() {
	return anonymity;
    }

    public void setAnonymity(boolean _anonymity) {
	anonymity = _anonymity;
    }

    public String getReplyTo() {
	return replyToId;
    }

    public void setReplyTo(String _replyToId) {
	replyToId = _replyToId;
    }

    /*public String toXML() {
      // convert this forum to XML format:
      <?xml version=""1.0""?>
      <forum>
      <id>        </id>
      <sender>    </sender>
      <body>      </body>
      <date>      </date>
      <replyToId> </replyToId>
      </forum>


      //StringBuffer xml = new StringBuffer ("<?xml version=""1.0""?>");
      xml.append(<forum>);
      if (id == null)
      xml.append("<id>null</id>");
      else
      xml.append("<id>" + id + "</id>");
      xml.append("<sender>" + sender + "</sender>");
      xml.append("<body>" + body + "</body>");
      xml.append("<date>" + date.getTime() + "</date>");
      if (replyToId == null)
      xml.append("<replyToId>null</replyToId>");
      else
      xml.append("<replyToId>" + replyToId + "</replyToId>");
      xml.append(</forum>);

      return xml.toString();
      } */
}
