package colab.util.group;

import java.io.Serializable;
import java.util.Vector;

public class LoggedUser implements Serializable {

    private String    roomName;
    private User      user;
    private transient iGroupClient client;
    private int       refuses = 0;

    public LoggedUser (User _user, String _roomName, iGroupClient _client) {
	user     = _user;
	roomName = _roomName;
	client   = _client;
    }

    public LoggedUser (LoggedUser _lUser) {
	user     = _lUser.user;
	roomName = _lUser.roomName;
	client   = _lUser.client;
    }

    public String getRoomName() {
	return this.roomName;
    }

    public void setRoomName (String _room) {
	this.roomName = _room;
    }

    public String getName() {
	return user.getName();
    }

    public Group getGroup () {
	return user.getGroup();
    }

    public String getLogin () {
	return user.getLogin();
    }

    public int getType () {
	return user.getType();
    }

//      public boolean equals (Object _user){
//  	return user.getLogin().equals ( ((LoggedUser)_user).getLogin());
//      }

    public iGroupClient getGroupClient(){
	return client;
    }

    public void setGroupClient (iGroupClient _client){
	client = _client;
    }

    public int getRefuses() {
	return refuses;
    }

    public void incRefuses() {
	refuses++;
    }

    public void resetRefuses() {
	refuses = 0;
    }
}
