package colab.util.group;

import java.io.Serializable;
import java.util.Vector;

public class User implements Serializable {

    // TYPES OF USER
    public static final int STUDENT = 1;
    public static final int TEACHER = 2;
    public static final int MONITOR = 3;
    public static final int GROUP   = 4;
    public static final String strStudent = "Aluno";
    public static final String strTeacher = "Professor";
    public static final String strMonitor = "Monitor";
    public static final String strGroup   = "Grupo";

    protected String login;
    protected String name;
    protected Group  group;
    protected int    type;

    public static String getNameType (int _type) {

	switch (_type) {
	case STUDENT:
	    return strStudent;
	case TEACHER:
	    return strTeacher;
	case MONITOR:
	    return strMonitor;
	case GROUP:
	    return strGroup;
	}

	return null;
    }

    public User (User _user) {
	name  = _user.getName();
	group = _user.getGroup();
	type  = _user.getType();
	login = _user.getLogin();
    }

    public User (String _name, int _type, String _login) {
	name = new String (_name);
	group = null;
	type = _type;
	login = new String (_login);
    }

    public User (String _name, Group _group, int _type, String _login) {
	name = new String (_name);
	group = _group;
	type = _type;
	login = new String (_login);
    }

    public User (String _name, int _type) {
	name = new String (_name);
	group = null;
	type = _type;
	login = null;
    }

    public String getName() {
	return this.name;
    }

    public void setName (String _name) {
	this.name = new String (_name);
    }

    public Group getGroup () {
	return this.group;
    }

    public void setGroup (Group _group) {
	this.group = _group;
    }

    public int getType () {
	return this.type;
    }

    public void setType (int _type) {
	this.type = _type;
    }

    public String getLogin () {
	return this.login;
    }

    public void setLogin (String _login) {
	this.login = _login;
    }

    public int getLogins (Vector v) {
	v.add (this.login);
	return 1;
    }

    public int getUsers (Vector v) {
	v.add (this);
	return 1;
    }
}
