package colab.util.group;

import java.rmi.Remote;
import java.rmi.RemoteException;
import colab.util.*;
import colab.util.*;

public interface iGroupServer extends Remote {

    //EVENTS
    public static final int USERIN   = 0;
    public static final int USEROUT  = 1;
    public static final int USERMOVE = 2;
    public static final String[] eventNames = {"UserIn", "UserOut", "UserMove"};

    public static final String NAME = "GroupServer";

    public void exit() throws RemoteException;

    public User login(String _login, String _password) throws RemoteException, LoginFailException, ServerIsGoingDownException;

    public void logout(String _login) throws RemoteException, LoginFailException, ServerIsGoingDownException;

    public UserInformation[] subscribe(String _login, iGroupClient _client) throws RemoteException, ServerIsGoingDownException;

    public String[] getLoginNames() throws RemoteException, ServerIsGoingDownException;

    public User getUserInformation (String _login) throws RemoteException, ServerIsGoingDownException;

    public void userGetOutARoom (String _login, String _room)throws RemoteException, ServerIsGoingDownException;

    public void userGetInARoom (String _login, String _room) throws RemoteException, ServerIsGoingDownException;
}
