package colab.util.mail;

import colab.util.*;
import java.util.*;
import java.io.*;

public class MailMsg implements iMailMsg {

    private String   sender;
    private String   destiny;
    private String   subject;
    private String   id;
    private Date     date;
    private String   replyToId;
    private String   body;

    public MailMsg (String _sender, String _destiny, String _subject, String _body) {
	sender    =  _sender;
	destiny   = _destiny;
	subject   = _subject;
	body      = _body;
	id        = null;
	date      = new Date();
	replyToId = null;
    }

    public MailMsg (String _sender, String _destiny, String _subject, String _body, String _replyToId) {
	sender    =  _sender;
	destiny   = _destiny;
	subject   = _subject;
	body      = _body;
	id        = null;
	date      = new Date();
	replyToId = _replyToId;
    }

    public String getSubject() {
	return subject;
    }

    public void setSubject(String _subject) {
	subject = _subject;
    }

    public boolean getReaded () {
	// only avaiable with PersonalizedMailMsg
	return false;
    }

    public void setReaded (boolean _readed) {
	// only avaiable with PersonalizedMailMsg
    }

    public String getSender() {
	return sender;
    }

    public void setSender(String _sender) {
	sender = new String (_sender);
    }

    public String getDestiny() {
	return destiny;
    }

    public void setDestiny(String _destiny) {
	destiny = new String (_destiny);
    }

    public String getBody() {
	return body;
    }

    public void setBody(String _body) {
	body = _body;
    }

    public String getId() {
	return id;
    }

    public void setId (String _id) {
	id = new String (_id);
    }

    public Date getDate() {
	return date;
    }

    public void setDate(Date _date) {
	date = _date;
    }

    public String getReplyTo() {
	return replyToId;
    }

    public void setReplyTo(String _replyToId) {
	replyToId = new String (_replyToId);
    }

    /*public String toXML() {
      // convert this mail to XML format:
      <?xml version=""1.0""?>
      <mail>
      <id>        </id>
      <sender>    </sender>
      <destiny>   </destiny>
      <body>      </body>
      <date>      </date>
      <replyToId> </replyToId>
      </mail>


      //StringBuffer xml = new StringBuffer ("<?xml version=""1.0""?>");
      xml.append(<mail>);
      if (id == null)
      xml.append("<id>null</id>");
      else
      xml.append("<id>" + id + "</id>");
      xml.append("<sender>" + sender + "</sender>");
      xml.append("<destiny>" + destiny + "</destiny>");
      xml.append("<body>" + body + "</body>");
      xml.append("<date>" + date.getTime() + "</date>");
      if (replyToId == null)
      xml.append("<replyToId>null</replyToId>");
      else
      xml.append("<replyToId>" + replyToId + "</replyToId>");
      xml.append(</mail>);

      return xml.toString();
      } */
}
