package colab.util.tool.ploter;

import java.io.*;
import java.util.*;
import java.awt.Color;

public class Function implements Serializable {

    private static final Color DEFAULT_COLOR = Color.black;

    private String       name;
    private String       id;
    private String       functionString;
    private Map          parmsMap;
    private Color        color;
    private FunctionLock lock;

    // dominion
    private String       xMin;
    private String       xMax;

    // visibitily
    private boolean      invisible;

    public Function (String _name, String _function) {

	name           = _name;
	functionString = _function;
	color          = DEFAULT_COLOR;
	invisible      = false;

    }

    public Function (String _name, String _function, FunctionLock _lock) {

	name           = _name;
	functionString = _function;
	color          = DEFAULT_COLOR;
	lock           = _lock;
	invisible      = false;

    }

    public Function (String _name, String _function, FunctionLock _lock, Color _color) {

	name           = _name;
	functionString = _function;
	color          = _color;
	lock           = _lock;
	invisible      = false;

    }

    public boolean sameTrace ( Function _f) {

	return _f.getFunctionString().equals( this.functionString);

    }


    public String getName () {

	return name;

    }


    public void setName (String _name) {

	name = _name;

    }


    public String getId() {

	return id;

    }


    public void setId(String _id) {

	id = _id;

    }


    public String getFunctionString () {

	return functionString;

    }

    public void setFunctionString (String _functionString) {

	functionString = _functionString;

    }

    public String[] getParameterList () {

	return null;

    }

    public float getParameter (String _parm) {

	return 0;

    }

    public void setParameter (String _parm, float _val){

    }


    public Color getColor() {

  	if (null != lock) {
  	    //System.out.println ("getColor;Tem lock");
  	    if (null != lock.getColor())
  		return lock.getColor();
  	}

	return color;

    }

    public void setColor (Color _color) {

	color = _color;

    }

    public FunctionLock getFunctionLock () {

	return lock;

    }

    public void setFunctionLock (FunctionLock _lock) {

	lock = _lock;

    }

    public String getXMin() {

	if (null == xMin)
	    xMin = new String("");

	return xMin;

    }

    public void setXMin (String _xMin) {

	this.xMin = _xMin;

    }

    public String getXMax() {

	if (null == xMax)
	    xMax = new String("");

	return xMax;

    }

    public void setXMax (String _xMax) {

	this.xMax = _xMax;

    }

    public boolean getInvisible() {

	return invisible;

    }

    public void setInvisible (boolean _invisible) {

	this.invisible = _invisible;

    }

    public Object clone () {
  	Function f = new Function (this.name, this.functionString);
  	f.color = this.color;
  	f.xMin = this.xMin;
  	f.xMax = this.xMax;

  	return f;
    }
}
