package colab.util.tool.ploter;

import java.io.Serializable;
import colab.util.tool.*;

public class PloterModelEvent implements iEvent {

    //Event types

    public final static int FUNCTION_CHANGED  = 1;
    public final static int BOUND_CHANGED     = 2;
    public final static int FUNCTION_INSERTED = 3;
    public final static int FUNCTION_REMOVED  = 4;
    //public final static int FUNCTION_LOCKED   = 5;
    //public final static int FUNCTION_UNLOCKED = 6;

    private int          type;
    private String       id;
    private Function     function;
    private Bound        bound;


    public PloterModelEvent (int _type, String _id, Function _func, Bound _bound) {

	id           = _id;
	function     = _func;
	type         = _type;
	bound        = _bound;

    }


    public int getType() {

	return type;

    }


    public String getId() {

	return id;

    }


    public Function getFunction() {

	return function;

    }


    public Bound getBound () {

	return bound;

    }
}
