package colab.util.tool.ploter;

import java.rmi.*;
import java.awt.*;
import colab.util.tool.iToolModel;

public interface iPloterModel extends iToolModel {

    Function[] getFunctionList() throws RemoteException;

    void setModel (PloterModel _model) throws RemoteException, FunctionLockException;

    // return true if there is at least one function locked
    //  ------>>  it's NOT thread-safe  <<------  //
    boolean verifyLocks () throws RemoteException;

    String getValidName() throws RemoteException;

    String addFunction(Function _func) throws RemoteException;

    void changeFunction (String _id, Function _func, FunctionLock _functionLock)
	throws RemoteException, FunctionLockException, FunctionNotFoundException;

    public void changeColor (String _id, Color _color) throws RemoteException;

    Function getFunction (String _id) throws RemoteException;

    boolean removeFunction (String _id) throws RemoteException, FunctionLockException;

    void removeAllFunctions () throws RemoteException, FunctionLockException;

    Note[] getNoteList() throws RemoteException;

    void addNote(Note _note) throws RemoteException;

    boolean removeNote (Note _note) throws RemoteException;

    Bound getBound() throws RemoteException;

    void setBound (Bound _bound) throws RemoteException;

//      void addPloterListener(iPloterListener pListener) throws RemoteException;

//      void removePloterListener(iPloterListener pListener) throws RemoteException;

    public void setAllInvisible () throws RemoteException;

    boolean lockFunction (String _functionId, FunctionLock _lock)
	throws RemoteException, FunctionLockException, FunctionNotFoundException;

    void unlockFunction (FunctionLock _functionLock, String _functionId) throws RemoteException, FunctionLockException;

    PloterModel cloneModel () throws RemoteException;
}
